// DEPRECIATED
// This code is not used, but I left it here incase anybody wants to look

$WindVector = "0 0 0";

$StaticProjectileGroup = new SimSet();

function eulerToAxis(%euler)
{
	%euler = VectorScale(%euler,$pi / 180);
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix,3,6);
}

function axisToEuler(%axis)
{
	%angleOver2 = getWord(%axis,3) * 0.5;
	%angleOver2 = -%angleOver2;
	%sinThetaOver2 = mSin(%angleOver2);
	%cosThetaOver2 = mCos(%angleOver2);
	%q0 = %cosThetaOver2;
	%q1 = getWord(%axis,0) * %sinThetaOver2;
	%q2 = getWord(%axis,1) * %sinThetaOver2;
	%q3 = getWord(%axis,2) * %sinThetaOver2;
	%q0q0 = %q0 * %q0;
	%q1q2 = %q1 * %q2;
	%q0q3 = %q0 * %q3;
	%q1q3 = %q1 * %q3;
	%q0q2 = %q0 * %q2;
	%q2q2 = %q2 * %q2;
	%q2q3 = %q2 * %q3;
	%q0q1 = %q0 * %q1;
	%q3q3 = %q3 * %q3;
	%m13 = 2.0 * (%q1q3 - %q0q2);
	%m21 = 2.0 * (%q1q2 - %q0q3);
	%m22 = 2.0 * %q0q0 - 1.0 + 2.0 * %q2q2;
	%m23 = 2.0 * (%q2q3 + %q0q1);
	%m33 = 2.0 * %q0q0 - 1.0 + 2.0 * %q3q3;
	return mRadToDeg(mAsin(%m23)) SPC mRadToDeg(mAtan(-%m13, %m33)) SPC mRadToDeg(mAtan(-%m21, %m22));
}

function Normal2Rotation(%normal)  
{  
   if(getWord(%normal, 2) == 1 || getWord(%normal, 2) == -1)  
      %rotAxis = vectorNormalize(vectorCross(%normal, "0 1 0"));  
   else  
      %rotAxis = vectorNormalize(vectorCross(%normal, "0 0 1"));  
  
   %initialAngle = mACos(vectorDot(%normal, "0 0 1"));  
   %rotation = %rotAxis SPC (%initialAngle);  
  
   return %rotation;  
}

forceRequiredAddon("Weapon_Gun");

function getSwayVector(%sway)
{
	return getSway(%sway) SPC getSway(%sway) SPC 0;
}
function getSway(%sway)
{
	return getRandom() * 0.0001 * getRandom(-1, 1) * %sway;
}
function createStaticProjectile(%client, %initialPosition, %vector, %stepSpeed, %stepDistance, %projectile, %zero, %spread, %step, %initPos)
{
	//echo("Spawning" SPC %projectile SPC "at pos" SPC %initialPosition SPC "with vector" SPC %vector SPC "step speed of" SPC %stepSpeed SPC "dist" SPC %stepDistance);

	if(!%step)
	{
		%initPos = %initialPosition;
		%vector = vectorNormalize(vectorAdd(%vector, "0 0" SPC %zero));
	}
	
	// player vars
	%player = %client.player;
	
	// init raycast
	%start = %initialPosition;
	%end = vectorAdd(%start, vectorScale(%vector, %stepDistance));
	%mask = $TypeMasks::FxBrickObjectType |
			$TypeMasks::PlayerObjectType |
			$TypeMasks::VehicleObjectType |
			$TypeMasks::TerrainObjectType;
			
	%raycast = containerRayCast(%start, %end, %mask, %player);
	%hit = getWord(%raycast, 0);
	
	// for when we hit something
	if(%hit)
	{
		%realProjectile = new Projectile()
		{
			datablock = %projectile;
			initialPosition = vectorAdd(getWords(%raycast, 1, 3), vectorScale(%vector, -0.1));
			initialVelocity = vectorScale(%vector, 200);
			client = %client;
			sourceObj = %client.player;
		};
		%realProjectile.dontHurtShooter = true;
		return;
	}
	
	// didn't hit anything
	// get some info about our projectile
	%data = %projectile;
	%effectiveRange = %data.effectiveRange;
	%totalRange = %data.totalRange;
	%gravity = %data.gravityMod;
	%sway = %data.swayMod;
	%speedBonus = %data.effectiveSpeedBonus;
	%useFakeProjectileEffect = %data.spawnFakeProjectiles;
	
	// didn't find what we needed, set def values
	if(%totalRange $= "")
		%totalRange = 2000;
		
	if(%effectiveRange $= "")
		%effectiveRange = 200;
		
	if(%sway $= "")
		%sway = 0;
		
	if(%speedBonus $= "")
		%speedBonus = 1;
		
	// get our current range
	%currentRange = vectorDist(%initPos, %end);
	
	/////////////////// debug shit
	//%gravity = 0.2;
	//%sway = 5;
	//%speedBonus = 2;
	///////////////////
	
	if(%currentRange > %effectiveRange)
	{
		// outside effective range
		// wind and sway
		%vector = vectorNormalize(vectorAdd(vectorAdd(%vector, vectorScale($WindVector, %sway)), getSwayVector(%sway)));
		
		// gravity
		%gravity = %gravity * 0.001;
		%vector = vectorNormalize(vectorAdd(%vector, "0 0" SPC %gravity * -1));
	}
	
	// spawn fast moving projectile at that position and vector, remove it later
	// gives the illusion of great speed
	if(%useFakeProjectileEffect)
	{
		%currentThreadCount = $StaticProjectileGroup.getCount();
		if(%currentThreadCount > 1)
		{
			%quality = %currentThreadCount - 1;
		}
		
		if(%quality < 1)
			%quality = 1;
		
		if(%step % %quality == 0 && %quality < 5)
		{
			%projectileGhost = new Projectile()
			{
				datablock = %projectile;
				initialPosition = %end;  
				initialVelocity = vectorScale(%vector, 200);
			};
			// not a real projectile, just fake fx. we'll do stuff with this later
			$StaticProjectileGroup.add(%projectileGhost);
			%projectileGhost.isFakeProjectileGhost = true;
			%projectileGhost.schedule(%stepSpeed * %quality, delete);
		}
	}
	
	// we're outside of our total range, don't continue
	if(%currentRange > %totalRange)
		return;
	
	// sentinel for bogus loops, 1000 is still even a massive value, could probably be 200
	if(%step > 1000)
		return;
	
	// next step
	schedule(%stepSpeed, %client, createStaticProjectile, %client, %end, %vector, %stepSpeed, %stepDistance, %projectile, %zero, %spread, %step++, %initPos);
}

function gameConnection::spawnStaticProjectileFromEye(%client)
{
	createStaticProjectile(%client, %client.player.getEyePoint(), %client.player.getEyeVector(), 80, 80, gunProjectile, 0.0);
}

package staticProjectilePackage
{
	function ProjectileData::onCollision(%this, %obj, %col, %fade, %pos, %normal, %velocity)
	{
		if(%obj.isFakeProjectileGhost)
		{
			%obj.delete();
			return;
		}
		
		if(%obj.dontHurtShooter && %col.client == %obj.client)
		{
			return;
		}
		
		Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal, %velocity);
	}

};
activatePackage(staticProjectilePackage);